4 USAGE='<fetch-options> <repository> <refspec>...'
7 set_reflog_action "fetch $*"
8 cd_to_toplevel ;# probably unnecessary...
11 _x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
12 _x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
27 while case "$#" in 0) break ;; esac
30 -a|--a|--ap|--app|--appe|--appen|--append)
33 --upl|--uplo|--uploa|--upload|--upload-|--upload-p|\
34 --upload-pa|--upload-pac|--upload-pack)
36 exec="--upload-pack=$1"
38 --upl=*|--uplo=*|--uploa=*|--upload=*|\
39 --upload-=*|--upload-p=*|--upload-pa=*|--upload-pac=*|--upload-pack=*)
40 exec=--upload-pack=$(expr "z$1" : 'z-[^=]*=\(.*\)')
43 -f|--f|--fo|--for|--forc|--force)
46 -t|--t|--ta|--tag|--tags)
49 -n|--n|--no|--no-|--no-t|--no-ta|--no-tag|--no-tags)
52 -u|--u|--up|--upd|--upda|--updat|--update|--update-|--update-h|\
53 --update-he|--update-hea|--update-head|--update-head-|\
54 --update-head-o|--update-head-ok)
60 -k|--k|--ke|--kee|--keep)
64 shallow_depth="--depth=`expr "z$1" : 'z-[^=]*=\(.*\)'`"
68 shallow_depth="--depth=$1"
82 origin=$(get_default_remote)
83 test -n "$(get_remote_url ${origin})" ||
84 die "Where do you want to fetch from today?"
85 set x $origin ; shift ;;
90 # No command line override and we have configuration for the remote.
91 exec="--upload-pack=$(get_uploadpack $1)"
95 remote=$(get_remote_url "$@")
98 rsync_slurped_objects=
100 if test "" = "$append"
102 : >"$GIT_DIR/FETCH_HEAD"
105 # Global that is reused later
106 ls_remote_result=$(git ls-remote $exec "$remote") ||
107 die "Cannot get the repository state from $remote"
109 append_fetch_head () {
116 t) not_for_merge_='not-for-merge' ;;
117 '') not_for_merge_= ;;
120 # remote-nick is the URL given on the command line (or a shorthand)
121 # remote-name is the $GIT_DIR relative refs/ path we computed
124 # the $note_ variable will be fed to git-fmt-merge-msg for further
126 case "$remote_name_" in
130 note_="$(expr "$remote_name_" : 'refs/heads/\(.*\)')"
131 note_="branch '$note_' of " ;;
133 note_="$(expr "$remote_name_" : 'refs/tags/\(.*\)')"
134 note_="tag '$note_' of " ;;
136 note_="$(expr "$remote_name_" : 'refs/remotes/\(.*\)')"
137 note_="remote branch '$note_' of " ;;
139 note_="$remote_name of " ;;
141 remote_1_=$(expr "z$remote_" : 'z\(.*\)\.git/*$') &&
143 note_="$note_$remote_"
145 # 2.6.11-tree tag would not be happy to be fed to resolve.
146 if git-cat-file commit "$head_" >/dev/null 2>&1
148 headc_=$(git-rev-parse --verify "$head_^0") || exit
149 echo "$headc_ $not_for_merge_ $note_" >>"$GIT_DIR/FETCH_HEAD"
151 echo "$head_ not-for-merge $note_" >>"$GIT_DIR/FETCH_HEAD"
154 update_local_ref "$local_name_" "$head_" "$note_"
157 update_local_ref () {
158 # If we are storing the head locally make sure that it is
159 # a fast forward (aka "reverse push").
161 label_=$(git-cat-file -t $2)
162 newshort_=$(git-rev-parse --short $2)
163 if test -z "$1" ; then
164 [ "$verbose" ] && echo >&2 "* fetched $3"
165 [ "$verbose" ] && echo >&2 " $label_: $newshort_"
168 oldshort_=$(git show-ref --hash --abbrev "$1" 2>/dev/null)
172 # Tags need not be pointing at commits so there
173 # is no way to guarantee "fast-forward" anyway.
174 if test -n "$oldshort_"
176 if now_=$(git show-ref --hash "$1") && test "$now_" = "$2"
178 [ "$verbose" ] && echo >&2 "* $1: same as $3"
179 [ "$verbose" ] && echo >&2 " $label_: $newshort_" ||:
181 echo >&2 "* $1: updating with $3"
182 echo >&2 " $label_: $newshort_"
183 git-update-ref -m "$GIT_REFLOG_ACTION: updating tag" "$1" "$2"
186 echo >&2 "* $1: storing $3"
187 echo >&2 " $label_: $newshort_"
188 git-update-ref -m "$GIT_REFLOG_ACTION: storing tag" "$1" "$2"
192 refs/heads/* | refs/remotes/*)
193 # $1 is the ref being updated.
194 # $2 is the new value for the ref.
195 local=$(git-rev-parse --verify "$1^0" 2>/dev/null)
198 # Require fast-forward.
199 mb=$(git-merge-base "$local" "$2") &&
202 if test -n "$verbose"
204 echo >&2 "* $1: same as $3"
205 echo >&2 " $label_: $newshort_"
209 echo >&2 "* $1: fast forward to $3"
210 echo >&2 " old..new: $oldshort_..$newshort_"
211 git-update-ref -m "$GIT_REFLOG_ACTION: fast-forward" "$1" "$2" "$local"
217 case ",$force,$single_force," in
219 echo >&2 "* $1: forcing update to non-fast forward $3"
220 echo >&2 " old...new: $oldshort_...$newshort_"
221 git-update-ref -m "$GIT_REFLOG_ACTION: forced-update" "$1" "$2" "$local"
224 echo >&2 "* $1: not updating to non-fast forward $3"
225 echo >&2 " old...new: $oldshort_...$newshort_"
231 echo >&2 "* $1: storing $3"
232 echo >&2 " $label_: $newshort_"
233 git-update-ref -m "$GIT_REFLOG_ACTION: storing head" "$1" "$2"
239 # updating the current HEAD with git-fetch in a bare
240 # repository is always fine.
241 if test -z "$update_head_ok" && test $(is_bare_repository) = false
243 orig_head=$(git-rev-parse --verify HEAD 2>/dev/null)
246 # Allow --notags from remote.$1.tagopt
247 case "$tags$no_tags" in
249 case "$(git-config --get "remote.$1.tagopt")" in
255 # If --tags (and later --heads or --all) is specified, then we are
256 # not talking about defaults stored in Pull: line of remotes or
257 # branches file, and just fetch those and refspecs explicitly given.
258 # Otherwise we do what we always did.
260 reflist=$(get_remote_refs_for_fetch "$@")
264 echo "$ls_remote_result" |
265 git-show-ref --exclude-existing=refs/tags/ |
268 echo ".${name}:${name}"
272 # remote URL plus explicit refspecs; we need to merge them.
273 reflist="$reflist$LF$taglist"
275 # No explicit refspecs; fetch tags only.
289 # These are relative path from $GIT_DIR, typically starting at refs/
291 if expr "z$ref" : 'z\.' >/dev/null
294 ref=$(expr "z$ref" : 'z\.\(.*\)')
298 if expr "z$ref" : 'z+' >/dev/null
301 ref=$(expr "z$ref" : 'z+\(.*\)')
305 remote_name=$(expr "z$ref" : 'z\([^:]*\):')
306 local_name=$(expr "z$ref" : 'z[^:]*:\(.*\)')
308 rref="$rref$LF$remote_name"
310 # There are transports that can fetch only one head at a time...
312 http://* | https://* | ftp://*)
313 test -n "$shallow_depth" &&
314 die "shallow clone with http not supported"
315 proto=`expr "$remote" : '\([^:]*\):'`
316 if [ -n "$GIT_SSL_NO_VERIFY" ]; then
319 if [ -n "$GIT_CURL_FTP_NO_EPSV" -o \
320 "`git-config --bool http.noEPSV`" = true ]; then
321 noepsv_opt="--disable-epsv"
324 # Find $remote_name from ls-remote output.
327 echo "$ls_remote_result" |
330 test "z$name" = "z$remote_name" || continue
335 expr "z$head" : "z$_x40\$" >/dev/null ||
336 die "No such ref $remote_name at $remote"
337 echo >&2 "Fetching $remote_name from $remote using $proto"
338 git-http-fetch -v -a "$head" "$remote/" || exit
341 test -n "$shallow_depth" &&
342 die "shallow clone with rsync not supported"
343 TMP_HEAD="$GIT_DIR/TMP_HEAD"
344 rsync -L -q "$remote/$remote_name" "$TMP_HEAD" || exit 1
345 head=$(git-rev-parse --verify TMP_HEAD)
347 test "$rsync_slurped_objects" || {
348 rsync -av --ignore-existing --exclude info \
349 "$remote/objects/" "$GIT_OBJECT_DIRECTORY/" || exit
351 # Look at objects/info/alternates for rsync -- http will
352 # support it natively and git native ones will do it on
353 # the remote end. Not having that file is not a crime.
354 rsync -q "$remote/objects/info/alternates" \
355 "$GIT_DIR/TMP_ALT" 2>/dev/null ||
356 rm -f "$GIT_DIR/TMP_ALT"
357 if test -f "$GIT_DIR/TMP_ALT"
359 resolve_alternates "$remote" <"$GIT_DIR/TMP_ALT" |
362 case "$alt" in 'bad alternate: '*) die "$alt";; esac
363 echo >&2 "Getting alternate: $alt"
364 rsync -av --ignore-existing --exclude info \
365 "$alt" "$GIT_OBJECT_DIRECTORY/" || exit
367 rm -f "$GIT_DIR/TMP_ALT"
369 rsync_slurped_objects=t
373 # We will do git native transport with just one call later.
377 append_fetch_head "$head" "$remote" \
378 "$remote_name" "$remote_nick" "$local_name" "$not_for_merge" || exit
383 http://* | https://* | ftp://* | rsync://* )
384 ;; # we are already done.
386 ( : subshell because we muck with IFS
389 git-fetch-pack --thin $exec $keep $shallow_depth "$remote" $rref ||
390 echo failed "$remote"
394 if test -n "$keepfile" && test -f "$keepfile"
401 while read sha1 remote_name
405 echo >&2 "Fetch failure: $remote"
407 # special line coming from index-pack with the pack name
411 keepfile="$GIT_OBJECT_DIRECTORY/pack/pack-$remote_name.keep"
439 local_name=$(expr "z$found" : 'z[^:]*:\(.*\)')
440 append_fetch_head "$sha1" "$remote" \
441 "$remote_name" "$remote_nick" "$local_name" \
442 "$not_for_merge" || exit
450 fetch_main "$reflist" || exit
452 # automated tag following
453 case "$no_tags$tags" in
457 # effective only when we are following remote branch
458 # using local tracking branch.
460 echo "$ls_remote_result" |
461 git-show-ref --exclude-existing=refs/tags/ |
464 git-cat-file -t "$sha1" >/dev/null 2>&1 || continue
465 echo >&2 "Auto-following $name"
466 echo ".${name}:${name}"
472 # do not deepen a shallow tree when following tags
474 fetch_main "$taglist" || exit ;;
478 # If the original head was empty (i.e. no "master" yet), or
479 # if we were told not to worry, we do not have to check.
484 curr_head=$(git-rev-parse --verify HEAD 2>/dev/null)
485 if test "$curr_head" != "$orig_head"
488 -m "$GIT_REFLOG_ACTION: Undoing incorrectly fetched HEAD." \
490 die "Cannot fetch into the current branch."